"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useAnd = exports.useIf = exports.use = exports.Eq = exports.And = exports.If = exports.False = exports.True = exports.falseSymb = exports.trueSymb = exports.andSymb = exports.ifSymb = exports.eqSymb = void 0;
const Utils_1 = require("../Utils");
const Lazify_1 = require("./Lazify");
exports.eqSymb = '@equ';
exports.ifSymb = 'if';
exports.andSymb = 'and';
exports.trueSymb = 'True';
exports.falseSymb = 'False';
exports.True = { name: exports.trueSymb, args: [] };
exports.False = { name: exports.falseSymb, args: [] };
const If = (cond, thenExp, elseExp) => {
    return Utils_1.fun(exports.ifSymb, cond, thenExp, elseExp);
};
exports.If = If;
const And = (a, b) => {
    return Utils_1.fun(exports.andSymb, a, b);
};
exports.And = And;
const Eq = (a, b) => {
    return Utils_1.fun(exports.eqSymb, a, b);
};
exports.Eq = Eq;
const use = (trs, rules) => {
    Utils_1.addRules(trs, ...rules);
};
exports.use = use;
const useIf = (trs, lazy = true) => {
    const a = Lazify_1.MaybeLazy('a', lazy);
    const b = Lazify_1.MaybeLazy('b', lazy);
    const ifRules = [
        [exports.If(exports.True, a, b), 'a'],
        [exports.If(exports.False, a, b), 'b']
    ];
    exports.use(trs, ifRules);
};
exports.useIf = useIf;
const useAnd = (trs) => {
    const andRules = [
        [exports.And(exports.False, exports.False), exports.False],
        [exports.And(exports.False, exports.True), exports.False],
        [exports.And(exports.True, exports.False), exports.False],
        [exports.And(exports.True, exports.True), exports.True]
    ];
    exports.use(trs, andRules);
};
exports.useAnd = useAnd;
