"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.normalizeLhsArgs = void 0;
const Types_1 = require("../../Types");
const Utils_1 = require("../Utils");
const DecisionTreeNormalizer_1 = require("../../Normalizer/DecisionTreeNormalizer");
const normalizeLhsArgs = exts => {
    return (trs) => {
        const newRules = [];
        const norm = new DecisionTreeNormalizer_1.DecisionTreeNormalizer(trs).asNormalizer(exts);
        for (const [lhs, rhs] of Utils_1.rules(trs)) {
            const r = [Utils_1.fun(lhs.name, ...lhs.args.map(norm)), rhs];
            newRules.push(r);
        }
        return Types_1.Ok(Utils_1.mapify(newRules));
    };
};
exports.normalizeLhsArgs = normalizeLhsArgs;
