"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.removeUnusedRules = void 0;
const Types_1 = require("../../Types");
const Utils_1 = require("../Utils");
const removeUnusedRules = (startingRule) => {
    return (trs) => {
        const usedRules = collectUsedRules(trs, startingRule);
        for (const ruleName of trs.keys()) {
            if (!usedRules.has(ruleName)) {
                trs.delete(ruleName);
            }
        }
        return Types_1.Ok(trs);
    };
};
exports.removeUnusedRules = removeUnusedRules;
const collectUsedRules = (trs, start, usedRules = new Set()) => {
    var _a;
    if (usedRules.has(start))
        return;
    const rules = (_a = trs.get(start)) !== null && _a !== void 0 ? _a : [];
    usedRules.add(start);
    for (const [lhs, rhs] of rules) {
        const symbs = [];
        for (const arg of lhs.args) {
            Utils_1.allSymbs(arg, symbs);
        }
        Utils_1.allSymbs(rhs, symbs);
        for (const f of symbs) {
            collectUsedRules(trs, f, usedRules);
        }
    }
    return usedRules;
};
