"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.simulateIfs = void 0;
const Types_1 = require("../../Types");
const Utils_1 = require("../Utils");
const Imports_1 = require("./Imports");
let ifsCount = 0;
const simulateIfs = (previousIfsCount = 0) => (trs) => {
    const newRules = [];
    const addRules = (rules) => { newRules.push(...rules); };
    ifsCount = previousIfsCount;
    for (const [lhs, rhs] of Utils_1.rules(trs)) {
        newRules.push([lhs, simIf(rhs, addRules)]);
    }
    return Types_1.Ok(Utils_1.mapify(newRules));
};
exports.simulateIfs = simulateIfs;
const simIf = (term, addRules) => {
    if (Utils_1.isVar(term))
        return term;
    if (term.name === Imports_1.ifSymb) {
        const ifName = `${Imports_1.ifSymb}_sim${ifsCount++}`;
        const [cond, thenExpr, elseExpr] = term.args;
        const simVars = Utils_1.uniq([...Utils_1.vars(thenExpr), ...Utils_1.vars(elseExpr)]);
        const sim = [
            [Utils_1.fun(ifName, Imports_1.True, ...simVars), simIf(thenExpr, addRules)],
            [Utils_1.fun(ifName, Imports_1.False, ...simVars), simIf(elseExpr, addRules)]
        ];
        addRules(sim);
        return Utils_1.fun(ifName, cond, ...simVars);
    }
    return Utils_1.fun(term.name, ...term.args.map(t => simIf(t, addRules)));
};
