"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ensureUniqueVarNames = void 0;
const Utils_1 = require("../../Parser/Utils");
const Types_1 = require("../../Types");
const Utils_2 = require("../Utils");
const varNamePrefix = 'var_';
// makes sure every variable appears exactly once (to prevent occurs check errors in other passes)
const ensureUniqueVarNames = (trs) => {
    let count = 0;
    for (const [_, rules] of trs) {
        for (const [[lhs, rhs], idx] of Utils_1.indexed(rules)) {
            const subst = Utils_2.associate(Utils_2.vars(lhs), () => `${varNamePrefix}${count++}`);
            rules[idx] = [Utils_2.substitute(lhs, subst), Utils_2.substitute(rhs, subst)];
        }
    }
    return Types_1.Ok(trs);
};
exports.ensureUniqueVarNames = ensureUniqueVarNames;
