"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.JSNormalizer = void 0;
const Utils_1 = require("../../Compiler/Utils");
const Parser_1 = require("../../Parser/Parser");
const Types_1 = require("../../Parser/Types");
const JSTranslator_1 = require("../../Translator/JSTranslator");
class JSNormalizer {
    constructor(trs, externals, executor) {
        this.trs = trs;
        this.externals = externals;
        this.executor = executor;
        this.trs = trs;
        if (!Types_1.dictHas(externals, 'show')) {
            throw new Error('@show must be included in the externals to use the JSNormalizer');
        }
        this.externals = externals;
    }
    getOutputExpr(query, jst) {
        return jst.callTerm(jst.renameTerm(Utils_1.stringifyQueryVars(Utils_1.fun('@show', query))));
    }
    normalize(query) {
        return __awaiter(this, void 0, void 0, function* () {
            const jst = new JSTranslator_1.JSTranslator(this.trs, this.externals);
            const source = jst.translate();
            const out = yield this.executor(source, this.getOutputExpr(query, jst));
            return Utils_1.defined(Parser_1.parseTerm(out));
        });
    }
    normalizeRaw(query) {
        return __awaiter(this, void 0, void 0, function* () {
            const jst = new JSTranslator_1.JSTranslator(this.trs, this.externals);
            const source = jst.translate();
            const out = yield this.executor(source, this.getOutputExpr(query, jst));
            return out;
        });
    }
}
exports.JSNormalizer = JSNormalizer;
