"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.nodeWorkerRawNormalizer = exports.nodeWorkerNormalizer = void 0;
const JSNormalizer_1 = require("./JSNormalizer");
const nodeWorkerExecutor = (source, outputExpr) => __awaiter(void 0, void 0, void 0, function* () {
    const sourceWithQuery = [
        source,
        "const { parentPort } = require('worker_threads');",
        `parentPort.once('message', () => { parentPort.postMessage(${outputExpr}); });`
    ].join('\n');
    const req = typeof __non_webpack_require__ !== 'undefined' ? __non_webpack_require__ : require;
    const { Worker } = req('worker_threads');
    const worker = new Worker(sourceWithQuery, { eval: true });
    return new Promise((resolve, reject) => {
        worker.on('message', out => {
            resolve(out);
        });
        worker.on('error', reject);
        worker.on('exit', code => {
            if (code !== 0) {
                reject(new Error(`Worker stopped with exit code ${code}`));
            }
        });
        worker.postMessage(null);
    });
});
const nodeWorkerNormalizer = (trs, externals) => {
    return (query) => new JSNormalizer_1.JSNormalizer(trs, externals, nodeWorkerExecutor).normalize(query);
};
exports.nodeWorkerNormalizer = nodeWorkerNormalizer;
const nodeWorkerRawNormalizer = (trs, externals) => {
    return (query) => new JSNormalizer_1.JSNormalizer(trs, externals, nodeWorkerExecutor).normalizeRaw(query);
};
exports.nodeWorkerRawNormalizer = nodeWorkerRawNormalizer;
