"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.webWorkerNormalizer = void 0;
const JSNormalizer_1 = require("./JSNormalizer");
const webWorkerExecutor = (source, outputExpr) => {
    const sourceWithQuery = [
        source,
        `self.onmessage = () => { postMessage(${outputExpr}); };`
    ].join('\n');
    const blob = new Blob([sourceWithQuery], { type: 'application/javascript' });
    const uri = URL.createObjectURL(blob);
    const worker = new Worker(uri);
    return new Promise(resolve => {
        worker.onmessage = (msg) => {
            resolve(msg.data);
        };
        worker.postMessage(null);
    });
};
const webWorkerNormalizer = (trs, externals) => {
    return (query) => new JSNormalizer_1.JSNormalizer(trs, externals, webWorkerExecutor).normalize(query);
};
exports.webWorkerNormalizer = webWorkerNormalizer;
