"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.undirectedUnify = void 0;
const Utils_1 = require("../Compiler/Utils");
const Types_1 = require("../Parser/Types");
const Utils_2 = require("../Parser/Utils");
const undirectedUnify = (s, t) => unify([[s, t]]);
exports.undirectedUnify = undirectedUnify;
// http://moscova.inria.fr/~levy/courses/X/IF/03/pi/levy2/martelli-montanari.pdf
const unify = (eqs, sigma = {}) => {
    if (eqs.length === 0)
        return sigma;
    let [s, t] = eqs.pop();
    // Decompose
    if (Utils_1.isFun(s) && Utils_1.isFun(t, s.name) &&
        s.args.length === t.args.length) {
        eqs.push(...Utils_1.zip(s.args, t.args));
        return unify(eqs, sigma);
    }
    // Delete (at this point s === t iff isVar(s) && isVar(t, s))
    if (s === t)
        return unify(eqs, sigma);
    if (Utils_1.isVar(t)) {
        [s, t] = [t, s];
    }
    // Eliminate
    if (Utils_1.isVar(s) && !Utils_1.occurs(s, t)) {
        Utils_2.mapMut(eqs, eq => Utils_2.mapMut(eq, u => Utils_1.substitute(u, sigma)));
        return unify(eqs, Types_1.dictSet(sigma, s, t));
    }
};
