"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.unreachable = exports.dictMap = exports.dictKeys = exports.dictValues = exports.dictEntries = exports.dictGet = exports.dictHas = exports.dictSet = void 0;
function dictSet(dict, key, value) {
    dict[key] = value;
    return dict;
}
exports.dictSet = dictSet;
function dictHas(dict, key) {
    // https://eslint.org/docs/rules/no-prototype-builtins
    return Object.prototype.hasOwnProperty.call(dict, key);
}
exports.dictHas = dictHas;
function dictGet(dict, key) {
    return dict[key];
}
exports.dictGet = dictGet;
function dictEntries(dict) {
    return Object.entries(dict);
}
exports.dictEntries = dictEntries;
function dictValues(dict) {
    return Object.values(dict);
}
exports.dictValues = dictValues;
function dictKeys(dict) {
    return Object.keys(dict);
}
exports.dictKeys = dictKeys;
function dictMap(dict, f) {
    const newDict = {};
    for (const [key, val] of dictEntries(dict)) {
        dictSet(newDict, key, f(val));
    }
    return newDict;
}
exports.dictMap = dictMap;
const unreachable = (msg = '') => {
    throw new Error(`Code marked as unreachable was reached: ${msg}`);
};
exports.unreachable = unreachable;
