"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.translate = void 0;
const HaskellTranslator_1 = require("./HaskellTranslator");
const JSTranslator_1 = require("./JSTranslator");
const OCamlTranslator_1 = require("./OCamlTranslator");
function translate(trs, target, externals) {
    let translator;
    switch (target) {
        case 'ocaml':
            translator = new OCamlTranslator_1.OCamlTranslator(trs, externals(target));
            break;
        case 'haskell':
            translator = new HaskellTranslator_1.HaskellTranslator(trs, externals(target));
            break;
        case 'js':
            translator = new JSTranslator_1.JSTranslator(trs, externals(target));
            break;
    }
    return translator.translate();
}
exports.translate = translate;
