import { Symb, Term } from "../../Parser/Types";
import { Maybe } from "../Utils";
import { AnyPat, IndexedOccurence, OccTerm } from "./DecisionTreeCompiler";
export declare type Leaf = {
    type: 'leaf';
    action: OccTerm;
};
export declare type Fail = {
    type: 'fail';
};
export declare type Switch = {
    type: 'switch';
    occurence: IndexedOccurence;
    tests: Array<[(Symb | AnyPat), DecisionTree]>;
};
export declare type DecisionTree = Leaf | Fail | Switch;
export declare const makeLeaf: (action: OccTerm) => Leaf;
export declare const makeFail: () => Fail;
export declare const makeSwitch: (occurence: IndexedOccurence, tests: Switch['tests']) => Switch;
export declare const getOccurence: (terms: Term[], occurence: IndexedOccurence) => Term;
export declare const isOccurence: (t: OccTerm) => t is IndexedOccurence;
export declare const termOf: (terms: Term[], occ: OccTerm) => Term;
export declare const evaluate: (args: Term[], dt: DecisionTree) => Maybe<Term>;
