import { Rule, Substitution, Term, TRS, Var } from "../../Parser/Types";
import { SourceCode, Translator } from "../../Translator/Translator";
import { DecisionTree } from "./DecisionTree";
import { Externals, Targets } from "../../Externals/Externals";
export declare abstract class DecisionTreeTranslator<Target extends Targets, Exts extends string> extends Translator<Target, Exts> {
    private arities;
    private signature;
    constructor(trs: TRS, externals: Externals<Target, Exts>);
    abstract translateDecisionTree(name: string, dt: DecisionTree, varNames: Var[]): SourceCode;
    abstract accessSubterm(parent: string, childIndex: number): SourceCode;
    protected collectVarNames(t: Term, sigma: Substitution, newVars: Var[], offset?: number, depth?: number, parent?: string): void;
    translateRules(name: string, rules: Rule[]): SourceCode;
}
