import { Fun, Rule } from "../../Parser/Types";
import { CompilationMessage, CompilerPass } from "./CompilerPass";
export declare type Checker = (rules: Rule[]) => CompilationMessage[];
export declare const check: (...checkers: Checker[]) => CompilerPass;
export declare const warn: (warningHandler: (warnings: CompilationMessage[]) => void, ...checkers: Checker[]) => CompilerPass;
export declare const checkArity: Checker;
export declare const isLeftLinear: ([lhs, _]: Rule) => boolean;
export declare const isFunLeftLinear: (f: Fun) => boolean;
export declare const checkLeftLinearity: Checker;
export declare const hasFreeVars: ([lhs, rhs]: Rule) => boolean;
export declare const checkNoFreeVars: Checker;
export declare const checkNoDuplicates: Checker;
export declare const checkTailRecursive: Checker;
export declare const allChecks: CompilerPass;
