import { Fun, Symb, Term, TRS } from "../../Parser/Types";
import { CompilerPass } from "./CompilerPass";
export declare type LazinessAnnotations = Map<Symb, boolean[]>;
export declare type Arities = Map<Symb, number>;
export declare const lazyAnnotationSymb = "Lazy";
export declare const instSymb = "inst";
export declare const thunkSymb = "\u0398";
export declare const Lazy: (term: Term) => Fun;
export declare const MaybeLazy: (term: Term, lazy?: boolean) => Term;
export declare const Inst: (...args: Term[]) => Fun;
export declare const Thunk: (name: Symb, ...args: Term[]) => Fun;
export declare const lazify: CompilerPass;
export declare const collectTRSArities: (trs: TRS) => Arities;
export declare const collectArity: (t: Term, arities: Arities) => void;
