import { Fun, Term } from "../Parser/Types";
import { StepNormalizer } from "../Normalizer/Normalizer";
import { SourceCode } from "../Translator/Translator";
export declare type Targets = 'js' | 'ocaml' | 'haskell';
export declare const supportedTargets: Targets[];
export declare type NativeExternals<Exts extends string = string> = {
    [name in Exts]: (t: Fun, normalizer: StepNormalizer, externals: NativeExternals<string>) => Term;
};
export declare type AnyExternals<Exts extends string = string> = Externals<Targets, Exts> | NativeExternals<Exts>;
export declare type Externals<Target extends string = Targets, Exts extends string = string> = {
    [key in Exts]: (name: string) => SourceCode;
};
export declare type ExternalsFactoryMap<Exts extends string = string, Ts extends string = Targets> = {
    'native': NativeExternals<Exts>;
} & {
    [target in Ts]: Externals<target, Exts>;
};
export declare type ExternalsFactory<Exts extends string = string, Ts extends string = Targets | 'native'> = <T extends Ts>(target: T) => ExternalsFactoryMap<Exts, Ts>[T];
export declare const mergeExternals: <Exts extends string, Ts extends string = "native" | Targets>(...factories: ExternalsFactory<Exts, "native" | Ts>[]) => ExternalsFactory<Exts, Ts>;
