import { normalizeQuery } from "./Normalizer";
import { Term } from "../Parser/Types";
import { CompilerPass } from "../Compiler/Passes/CompilerPass";
import { NativeExternals, Externals, ExternalsFactory } from "../Externals/Externals";
export declare type ExternalsMap<Exts extends string = string> = {
    'decision-trees': NativeExternals<Exts>;
    'head-matcher': NativeExternals<Exts>;
    'closure-matcher': NativeExternals<Exts>;
    'web-worker': Externals<'js', Exts>;
};
export declare type Normalizers = keyof ExternalsMap;
export declare const normalizersList: Normalizers[];
export declare const normalizeQueryWith: <N extends keyof ExternalsMap<string>>(normalizer: N) => (query: Term, source: string, externals: ExternalsFactory<string>, passes?: CompilerPass[]) => ReturnType<typeof normalizeQuery>;
