import { Maybe } from "../../Compiler/Utils";
import { Result } from "../../Types";
import { PositionInfo, SymbToken, Token, VarToken } from "./Token";
export declare const defaultLowerCaseSymbols: string[];
export declare const specialCharsSet: Set<string>;
export declare type LexerError = InvalidCharError | UnmatchingParensError;
export declare type InvalidCharError = {
    type: 'InvalidChar';
    char: string;
    position: PositionInfo;
};
export declare type UnmatchingParensError = {
    type: 'UnmatchingParens';
    name: string;
    position: PositionInfo;
};
export declare class Lexer {
    private source;
    private pos;
    private line;
    private col;
    private underscoresCount;
    private lowerCaseSymbols;
    private advance;
    currentChar(): string;
    private nextChar;
    tokenize(src: string): Result<Token[], LexerError>;
    private test;
    skipWhiteSpaces(): void;
    private position;
    private match;
    private matchLowercaseSymb;
    tokenizeVar(): Maybe<VarToken>;
    tokenizeSymb(): Maybe<SymbToken>;
    tokenizeString(str: string): () => Maybe<Token>;
    private isLowerCase;
    private isUpperCase;
    private isAlphaNum;
    private isAlpha;
    private isAllowedChar;
    setAcceptedLowerCaseSymbols(symbs: string[]): void;
}
