import { EmptyObject } from '../Types';
export declare type Token = VarToken | SymbToken | LeftParenToken | RightParenToken | CommaToken | LazyToken | ArrowToken;
export declare type PositionInfo = {
    line: number;
    col: number;
};
export declare type WithPos<S extends string, T = EmptyObject> = T & {
    type: S;
    position: PositionInfo;
};
export declare type VarToken = WithPos<'Var', {
    name: string;
}>;
export declare type SymbToken = WithPos<'Symb', {
    name: string;
}>;
export declare type LeftParenToken = WithPos<'('>;
export declare type RightParenToken = WithPos<')'>;
export declare type CommaToken = WithPos<','>;
export declare type LazyToken = WithPos<'?'>;
export declare type ArrowToken = WithPos<'->'>;
