import { Maybe } from "../../Compiler/Utils";
import { Source } from "../Source";
import { Either } from "../../Types";
import { ParserError } from "../TRSParser";
import { LexerError } from "../Lexer/Lexer";
import { EmptyObject } from "../Types";
export declare type PreprocessorResult = Maybe<Array<LexerError | ParserError>>;
export declare type PrepocessorPass<Info = EmptyObject> = (source: Source, passes: PrepocessorPass<Info>[], info: Partial<Info>) => Promise<PreprocessorResult>;
export declare function preprocess<Info extends EmptyObject = EmptyObject>(source: string | Source, passes: PrepocessorPass<Info>[], info?: Partial<Info>): Promise<Either<string, Array<ParserError | LexerError>>>;
