import { Maybe } from "../Compiler/Utils";
import { Result } from "../Types";
import { LexerError } from "./Lexer/Lexer";
import { Token, WithPos } from "./Lexer/Token";
import { Rule, Term } from "./Types";
export declare type ParserError = ExpectedLeftParen | ExpectedRightParen | ExpectedArrow | UnexpectedToken;
export declare type ExpectedLeftParen = WithPos<'ExpectedLeftParen'>;
export declare type ExpectedRightParen = WithPos<'ExpectedRightParen'>;
export declare type ExpectedArrow = WithPos<'ExpectedArrow'>;
export declare type UnexpectedToken = WithPos<'UnexpectedToken', {
    token: Token;
}>;
export declare class TRSParser {
    private pos;
    private tokens;
    private lexer;
    private static instance;
    private constructor();
    static getInstance(): TRSParser;
    tokenize(src: string): Maybe<LexerError>;
    parse(src: string): Result<Rule[], ParserError | LexerError>;
    parseTokens(tokens: Token[]): Result<Rule[], ParserError>;
    private currentToken;
    private nextToken;
    private advance;
    parseRule(): Result<Rule, ParserError>;
    parseTerm(): Result<Term, ParserError>;
    private parseVar;
    private parseFun;
}
