export declare type Var = string;
export declare type Symb = string;
export declare type Fun = {
    name: Symb;
    args: Term[];
};
export declare type Term = Var | Fun;
export declare type Dict<T> = {
    [key: string]: T;
};
export declare type Substitution = Dict<Term>;
export declare type Rule = [Fun, Term];
export declare type TRS = Map<Symb, Rule[]>;
export declare type EmptyObject = Record<string, unknown>;
export declare function dictSet<T>(dict: Dict<T>, key: string, value: T): Dict<T>;
export declare function dictHas<T>(dict: Dict<T>, key: string): boolean;
export declare function dictGet<T>(dict: Dict<T>, key: string): T;
export declare function dictEntries<T>(dict: Dict<T>): [string, T][];
export declare function dictValues<T>(dict: Dict<T>): T[];
export declare function dictKeys<T>(dict: Dict<T>): string[];
export declare function dictMap<T, U>(dict: Dict<T>, f: (val: T) => U): Dict<U>;
export declare const unreachable: (msg?: string) => never;
