import { Maybe } from "../Compiler/Utils";
import { Symb, Term } from "./Types";
export declare function reverse<T>(elems: T[]): Iterable<T>;
export declare function join<T>(as: Iterable<T>, bs: Iterable<T>): Iterable<T>;
export declare function once<T>(val: T): Iterable<T>;
export declare function iter<T>(vals: T[]): Iterable<T>;
export declare function some<T>(it: Iterable<T>, pred: (val: T) => boolean): boolean;
export declare function every<T>(it: Iterable<T>, pred: (val: T) => boolean): boolean;
export declare function find<T>(it: Iterable<T>, pred: (val: T) => boolean): Maybe<T>;
export declare function partition<T>(it: Iterable<T>, pred: (val: T) => boolean): [T[], T[]];
export declare function indexed<T>(vals: Iterable<T>): Iterable<[T, number]>;
export declare function range(from: number, to: number, step?: number): Iterable<number>;
export declare function map<U, V>(it: Iterable<U>, f: (val: U) => V): Iterable<V>;
export declare function repeat<T>(val: T, count: number): Iterable<T>;
export declare function union<T>(...sets: Set<T>[]): Set<T>;
export declare function intersection<T>(...sets: Set<T>[]): Set<T>;
export declare function unionMut<T>(a: Set<T>, ...sets: Set<T>[]): Set<T>;
export declare function intersectionMut<T>(a: Set<T>, ...sets: Set<T>[]): Set<T>;
export declare function setMap<U, V>(set: Set<U>, f: (val: U) => V): Set<V>;
export declare function setFilter<T>(set: Set<T>, f: (val: T) => boolean): Set<T>;
export declare function mapMut<U, V>(vals: U[], f: (val: U, index: number) => V): V[];
export declare function mapString(str: string, f: (char: string) => string): string;
export declare function time<T>(f: () => T): [number, T];
export declare function traverse(term: Term): Iterable<Term>;
export declare function traverseNames(term: Term): Iterable<Symb>;
export declare function pop<T>(elems: T[], count?: number): T[];
export declare function gen<T>(count: number, f: (idx: number) => T): Iterable<T>;
export declare const repeatString: (str: string, n: number) => string;
export declare const tabs: (count: number) => string;
export declare const indent: (tabCount: number, ...lines: string[]) => string;
export declare const format: (...lines: string[]) => string;
